////////////
//INCLUDES//
////////////
#include <iostream.h>
#include "ami_udp.h"

///////////////////
//UDP Tester Main//
///////////////////
int main(int argc, char *argv[])
{
	/////////////
	//Variables//
	/////////////
	struct WSAData MyWSA;
	SOCKET Socket; 
	unsigned short LocalUDPPort = 0;
	unsigned short RemoteUDPPort = 2639;
	SOCKADDR_IN LocalSin; 
	SOCKADDR_IN RemoteSin;
	
	char SendBuffer[MAXMSGLEN], 
		 RecvBuffer[MAXMSGLEN];
	char CR[2];
	char AMINetPrefix[4];
	char AMINetETX[2];
  char *ipstring="192.168.0.254";
  char CommandLineBuffer[MAXMSGLEN];

	unsigned int i;

	//Clear Send and Receive buffers
	for (i=0; i<MAXMSGLEN; i++)
	{
		SendBuffer[i] = '\0';
		RecvBuffer[i] = '\0';
		CommandLineBuffer[i] = '\0';
	}

	//Setup Carriage Return termination for commands sent
	CR[0] = 0x0d;
	CR[1] = '\0';

	//Setup AMINetPrefix with beginning of AMINet message wrapper
	AMINetPrefix[0] = (char)0xF1;
	AMINetPrefix[1] = (char)0x01;
	AMINetPrefix[2] = (char)0x04;
	AMINetPrefix[3] = '\0';

	//Setup AMINetETX with end transmission byte
	AMINetETX[0] = (char)0xF2;
	AMINetETX[1] = '\0';

	//Broadcast IP address
//	RemoteSin.sin_addr.s_addr = inet_addr("255.255.255.255");

	//Actual IP address
	RemoteSin.sin_addr.s_addr = inet_addr(ipstring);

	RemoteSin.sin_family = AF_INET;
	RemoteSin.sin_port = (unsigned short)htons(RemoteUDPPort);


  //Copy and filter the command line
  strcpy(CommandLineBuffer,argv[1]);
  for(i=0;i<strlen(CommandLineBuffer);i++)
  {
    if(i>=(MAXMSGLEN-10))break;                               //account for AMInet wrapper and CR
    if(CommandLineBuffer[i]=='\'') CommandLineBuffer[i]='\"'; 
  }

	//Build full AMINet compliant DVM2 Control Message
	strcpy(SendBuffer, AMINetPrefix);	//0xF1 0x01 0x04
	strcat(SendBuffer, CommandLineBuffer);		//message passed in
	strcat(SendBuffer, CR);				//0x0D
	AddAMINetChecksum(SendBuffer);		//Calculate (expand if necessary) and concatenate Checksum
	strcat(SendBuffer, AMINetETX);		//0xF2

	WSAStartup(WINSOCK_VERSION, &MyWSA);

	Socket = OpenSocket();

	if (Socket == SOCKET_ERROR)
		return -1;

	if (!SetStandardSocketOpts(Socket))
	{
		closesocket(Socket);
		return -1;
	}

	if (!BindSocketToPort(Socket, &LocalSin, LocalUDPPort))
	{
		closesocket(Socket);
		return -1;
	}

	if (!SendUDPMessage(Socket, SendBuffer, RemoteSin))
	{
		closesocket(Socket);
		return -1;
	}
	else
	{
		cout << "/---------------------------------------------------------------------\\" << endl;
		cout << "Sent UDP Packet containing " << CommandLineBuffer << " to Port " << RemoteUDPPort << " on "<<ipstring<<endl;
		cout << "..." << endl;
	}

	if(NULL==strrchr(SendBuffer, '@') || NULL!=strrchr(SendBuffer, '*') )
	{
		cout << "Wildcard used - no return expected." << endl;
		cout << "\\---------------------------------------------------------------------/\n\n" << endl;
	}
	else
	{
		if (!ReceiveUDPMessage(Socket, RecvBuffer))
		{
			closesocket(Socket);
			return -1;
		}
		else
		{
		cout << "Received UDP Packet on Port " << ntohs(LocalSin.sin_port) << endl;
		cout << "Data in received packet: " << RecvBuffer << endl;
		cout << "\\---------------------------------------------------------------------/\n\n" << endl;
		}
	}


	closesocket(Socket);
	return 1;

}
